import { JSONSchemaType } from "@golemio/core/dist/shared/ajv";
import { IOictBuildingsInput } from "./interfaces";

export const oictBuildingsJsonSchema: JSONSchemaType<IOictBuildingsInput[]> = {
    type: "array",
    items: {
        type: "object",
        properties: {
            id: { type: "integer" },
            name: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            description: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            buildingAddressCode: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            label: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            currentNote: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            mainUse: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            secondaryUse: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            yearOfConstruction: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            methodOfProtection: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            builtUpArea: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            heatedBuldingVolume: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            studentsCount: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            employeesCount: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            classroomsCount: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            bedsCount: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            enoId: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            csuCode: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            kuCode: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            allotmentNumber: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            registrationUnit: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            gasConsumptionNormatives: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            heatConsumptionNormatives: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            waterConsumptionNormatives: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            electricityConsumptionNormativesPerPerson: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            electricityConsumptionNormatives: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            energeticManagement: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            openingHours: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            weekendOpeningHours: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            latitude: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            longitude: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
            address: {
                type: "object",
                properties: {
                    street: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    houseNumber: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    city: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    country: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    mail: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    phone: { oneOf: [{ type: "string" }, { type: "integer" }, { type: "null", nullable: true }] },
                    webAddress: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                },
                required: ["street", "houseNumber", "city", "country", "mail", "phone", "webAddress"],
            },
            penb: {
                type: "object",
                properties: {
                    penbNumber: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                    issueDate: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    totalBuildingEnvelopeArea: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    volumeFactorOfAVShape: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    totalEnergyReferenceArea: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    totalProvidedEnergy: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    totalProvidedEnergyCategory: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    primaryNonRenewableEnergy: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    primaryNonRenewableEnergyCategory: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    buildingEnvelope: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    buildingEnvelopeCategory: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    heating: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    heatingCategory: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    cooling: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    coolingCategory: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    ventilation: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    ventilationCategory: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    humidityAdjustment: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    humidityAdjustmentCategory: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    warmWater: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    warmWaterCategory: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    lighting: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    lightingCategory: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                },
                required: [
                    "penbNumber",
                    "issueDate",
                    "totalBuildingEnvelopeArea",
                    "volumeFactorOfAVShape",
                    "totalEnergyReferenceArea",
                    "totalProvidedEnergy",
                    "totalProvidedEnergyCategory",
                    "primaryNonRenewableEnergy",
                    "primaryNonRenewableEnergyCategory",
                    "buildingEnvelope",
                    "buildingEnvelopeCategory",
                    "heating",
                    "heatingCategory",
                    "cooling",
                    "coolingCategory",
                    "ventilation",
                    "ventilationCategory",
                    "humidityAdjustment",
                    "humidityAdjustmentCategory",
                    "warmWater",
                    "warmWaterCategory",
                    "lighting",
                    "lightingCategory",
                ],
            },
            energyAudits: {
                type: "object",
                properties: {
                    energyAudit: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                    eaRegistrationNumber: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                    createdAt: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                },
                required: ["energyAudit", "eaRegistrationNumber", "createdAt"],
            },
            buildingEnvelope: {
                type: "object",
                properties: {
                    sideWall: {
                        type: "object",
                        properties: {
                            prevailingConstruction: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            area: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            heatInsulation: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            yearOfAdjustment: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                            technicalCondition: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                        },
                        required: ["prevailingConstruction", "area", "heatInsulation", "yearOfAdjustment", "technicalCondition"],
                    },
                    fillingOfHole: {
                        type: "object",
                        properties: {
                            construction: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            area: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            yearOfAdjustment: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                            technicalCondition: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                        },
                        required: ["construction", "area", "yearOfAdjustment", "technicalCondition"],
                    },
                    roof: {
                        type: "object",
                        properties: {
                            construction: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            area: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            thermalInsulation: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            yearOfAdjustment: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                            technicalCondition: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                        },
                        required: ["construction", "area", "thermalInsulation", "yearOfAdjustment", "technicalCondition"],
                    },
                    floorOfTheLowestHeatedFloor: {
                        type: "object",
                        properties: {
                            construction: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            area: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            thermalInsulation: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            yearOfAdjustment: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                            technicalCondition: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                        },
                        required: ["construction", "area", "thermalInsulation", "yearOfAdjustment", "technicalCondition"],
                    },
                },
                required: ["sideWall", "fillingOfHole", "roof", "floorOfTheLowestHeatedFloor"],
            },
            fuelAndEnergy: {
                type: "object",
                properties: {
                    coal: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    gas: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    electricity: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    czt: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    oze: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                    other: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                },
                required: ["coal", "gas", "electricity", "czt", "oze", "other"],
            },
            technicalEquipment: {
                type: "object",
                properties: {
                    heating: {
                        type: "object",
                        properties: {
                            mainSourceOfHeat: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            heatPercentage: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            secondarySourceOfHeat: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            heatingSystem: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            year: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                            technicalCondition: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                        },
                        required: [
                            "mainSourceOfHeat",
                            "heatPercentage",
                            "secondarySourceOfHeat",
                            "heatingSystem",
                            "year",
                            "technicalCondition",
                        ],
                    },
                    cooling: {
                        type: "object",
                        properties: {
                            coolingSystem: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            coolingAreaPercentage: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                            year: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                            technicalCondition: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                        },
                        required: ["coolingSystem", "coolingAreaPercentage", "year", "technicalCondition"],
                    },
                    ventilation: {
                        type: "object",
                        properties: {
                            ventilation: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            year: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                            technicalCondition: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                        },
                        required: ["ventilation", "year", "technicalCondition"],
                    },
                    humidityAdjustment: {
                        type: "object",
                        properties: {
                            humidityAdjustment: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            year: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                            technicalCondition: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                        },
                        required: ["humidityAdjustment", "year", "technicalCondition"],
                    },
                    hotWater: {
                        type: "object",
                        properties: {
                            predominantWayOfHeatingTv: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            hotWaterSource: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            year: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                            technicalCondition: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                        },
                        required: ["predominantWayOfHeatingTv", "hotWaterSource", "year", "technicalCondition"],
                    },
                    lighting: {
                        type: "object",
                        properties: {
                            lighting: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                            year: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                            technicalCondition: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                            otherTechnologicalElements: {
                                oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                            },
                            measurementMethod: { oneOf: [{ type: "string" }, { type: "null", nullable: true }] },
                        },
                        required: ["lighting", "year", "technicalCondition", "otherTechnologicalElements", "measurementMethod"],
                    },
                },
                required: ["heating", "cooling", "ventilation", "humidityAdjustment", "hotWater", "lighting"],
            },
            ozeEnergyProduction: {
                type: "object",
                properties: {
                    solarEnergyPhotovoltaic: {
                        oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                    },
                    solarEnergyPhotothermal: {
                        oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                    },
                    integratedTurbinesWindEnergy: {
                        oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }],
                    },
                    heatPump: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                },
                required: ["solarEnergyPhotovoltaic", "solarEnergyPhotothermal", "integratedTurbinesWindEnergy", "heatPump"],
            },
            wasteAndEmissions: {
                type: "object",
                properties: {
                    solidWasteProduction: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                    tiedCo2Emissions: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                    soxEmissions: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                    operatingCo2Emissions: { oneOf: [{ type: "string" }, { type: "number" }, { type: "null", nullable: true }] },
                },
                required: ["solidWasteProduction", "tiedCo2Emissions", "soxEmissions", "operatingCo2Emissions"],
            },
            link: {
                type: "string",
            },
        },
        required: [
            "id",
            "name",
            "description",
            "buildingAddressCode",
            "label",
            "currentNote",
            "mainUse",
            "secondaryUse",
            "yearOfConstruction",
            "methodOfProtection",
            "builtUpArea",
            "heatedBuldingVolume",
            "studentsCount",
            "employeesCount",
            "classroomsCount",
            "bedsCount",
            "enoId",
            "csuCode",
            "kuCode",
            "allotmentNumber",
            "registrationUnit",
            "gasConsumptionNormatives",
            "heatConsumptionNormatives",
            "waterConsumptionNormatives",
            "electricityConsumptionNormativesPerPerson",
            "electricityConsumptionNormatives",
            "energeticManagement",
            "openingHours",
            "weekendOpeningHours",
            "latitude",
            "longitude",
            "address",
            "penb",
            "energyAudits",
            "buildingEnvelope",
            "fuelAndEnergy",
            "technicalEquipment",
            "ozeEnergyProduction",
            "wasteAndEmissions",
            "link",
        ],
    },
};
